#ifndef DSL_H
#define DSL_H

unsigned char Last_Byte = 0, Byte_Count = 0, Checksum = 0, Packet_Lenght = 0;
unsigned char DSL_Packet[7], DSL_inArray[7][7], DSL_outArray[7][7];
unsigned char DSL_Header = 0;

int DSL_merge_Channel(unsigned char Byte1, unsigned char Byte2) {
	return ((255 * Byte1 + Byte2) - 11059);
}

void DSL_reverse_Channel(unsigned char *inByte1, unsigned char *inByte2, unsigned char *outByte1, unsigned char *outByte2) {
	int Channel = DSL_merge_Channel(*inByte1, *inByte2);
	Channel = ((-1) * Channel + 11059);
	*outByte1 = Channel / 255;
	*outByte2 = Channel % 255;	
}

void DSL_fill_outArray(void) {
	unsigned char i=0;

	// Sync & Status
	DSL_outArray[0][0] = 0x1F;		// Status Header
	DSL_outArray[0][1] = 35;		// Band
	DSL_outArray[0][2] = 240;		// Cannel
	DSL_outArray[0][3] = 200;		// RSSI
	DSL_outArray[0][4] = 200;		// Batterie
	DSL_outArray[0][5] = 0x01;		// 4bit Mode / 4bit Div. RSSI
	DSL_outArray[0][6] = ~(DSL_outArray[0][0] + DSL_outArray[0][1] + DSL_outArray[0][2] + DSL_outArray[0][3] + DSL_outArray[0][4] + DSL_outArray[0][5]); // Checksumme

	if ( DSL_merge_Channel(DSL_inArray[3][1], DSL_inArray[3][2]) > 0 ) {	// Channel 5 = Heigh?
		switch(DSL_Header) {
			case 0x10:
				// Servo 0 & Servo 1
				DSL_outArray[1][0] = 0x10;
				DSL_reverse_Channel(&DSL_inArray[1][1],&DSL_inArray[1][2],&DSL_outArray[1][1],&DSL_outArray[1][2]); // Byte 10 & Byte 11 (Servo 0)
				DSL_reverse_Channel(&DSL_inArray[1][3],&DSL_inArray[1][4],&DSL_outArray[1][3],&DSL_outArray[1][4]); // Byte 12 & Byte 13 (Servo 1)
				DSL_outArray[1][5] = ~(DSL_outArray[1][0] + DSL_outArray[1][1] + DSL_outArray[1][2] + DSL_outArray[1][3] + DSL_outArray[1][4]);	// Checksumme
			break;
			case 0x12:
				// Servo 2 & Servo 3
				DSL_outArray[2][0] = 0x12;
				DSL_reverse_Channel(&DSL_inArray[2][1],&DSL_inArray[2][2],&DSL_outArray[2][1],&DSL_outArray[2][2]); // Byte 10 & Byte 11 (Servo 0)
				DSL_reverse_Channel(&DSL_inArray[2][3],&DSL_inArray[2][4],&DSL_outArray[2][3],&DSL_outArray[2][4]); // Byte 12 & Byte 13 (Servo 1)
				DSL_outArray[2][5] = ~(DSL_outArray[2][0] + DSL_outArray[2][1] + DSL_outArray[2][2] + DSL_outArray[2][3] + DSL_outArray[2][4]);	// Checksumme
			break;
			case 0x14:
				// Servo 4 & Servo 5
				DSL_outArray[3][0] = 0x14;
				DSL_reverse_Channel(&DSL_inArray[3][1],&DSL_inArray[3][2],&DSL_outArray[3][1],&DSL_outArray[3][2]); // Byte 10 & Byte 11 (Servo 0)
				DSL_reverse_Channel(&DSL_inArray[3][3],&DSL_inArray[3][4],&DSL_outArray[3][3],&DSL_outArray[3][4]); // Byte 12 & Byte 13 (Servo 1)
				DSL_outArray[3][5] = ~(DSL_outArray[3][0] + DSL_outArray[3][1] + DSL_outArray[3][2] + DSL_outArray[3][3] + DSL_outArray[3][4]);	// Checksumme
			break;
			case 0x16:
				// Servo 6 & Servo 7
				DSL_outArray[4][0] = 0x16;
				DSL_reverse_Channel(&DSL_inArray[4][1],&DSL_inArray[4][2],&DSL_outArray[4][1],&DSL_outArray[4][2]); // Byte 10 & Byte 11 (Servo 0)
				DSL_reverse_Channel(&DSL_inArray[4][3],&DSL_inArray[4][4],&DSL_outArray[4][3],&DSL_outArray[4][4]); // Byte 12 & Byte 13 (Servo 1)
				DSL_outArray[4][5] = ~(DSL_outArray[4][0] + DSL_outArray[4][1] + DSL_outArray[4][2] + DSL_outArray[4][3] + DSL_outArray[4][4]);	// Checksumme
			break;
			case 0x18:
				// Servo 8 & Servo 9
				DSL_outArray[5][0] = 0x18;
				DSL_reverse_Channel(&DSL_inArray[5][1],&DSL_inArray[5][2],&DSL_outArray[5][1],&DSL_outArray[5][2]); // Byte 10 & Byte 11 (Servo 0)
				DSL_reverse_Channel(&DSL_inArray[5][3],&DSL_inArray[5][4],&DSL_outArray[5][3],&DSL_outArray[5][4]); // Byte 12 & Byte 13 (Servo 1)
				DSL_outArray[5][5] = ~(DSL_outArray[5][0] + DSL_outArray[5][1] + DSL_outArray[5][2] + DSL_outArray[5][3] + DSL_outArray[5][4]);	// Checksumme
			default: break;
		}
	} else {
		switch(DSL_Header) {
			case 0x10: for (i=0;i<6;i++) { DSL_outArray[1][i] = DSL_inArray[1][i]; }; break;
			case 0x12: for (i=0;i<6;i++) { DSL_outArray[2][i] = DSL_inArray[2][i]; }; break;
			case 0x14: for (i=0;i<6;i++) { DSL_outArray[3][i] = DSL_inArray[3][i]; }; break;
			case 0x16: for (i=0;i<6;i++) { DSL_outArray[4][i] = DSL_inArray[4][i]; }; break;
			case 0x18: for (i=0;i<6;i++) { DSL_outArray[5][i] = DSL_inArray[5][i]; }; break;
		}
	}
}


void DSL_fill_inArray(unsigned char Byte) {
	//char i=0;

	if ((Byte == 0xFF ) && (Last_Byte == 0xFF)) {
		Byte_Count = 0;
		Checksum = 0;
		return;
	}

	if (Byte_Count == 0) {
		if (Byte == 0x1F) {
			Packet_Lenght = 5;
		} else {
			Packet_Lenght = 4;
		}
	}

	if (Byte_Count > Packet_Lenght) {
		DSL_Packet[Byte_Count] = Byte;

		Checksum = ~Checksum;
		if (Checksum == 0xFF) {
			Checksum =0xFE;
		}

		if (Byte == Checksum) {
				// Packet ist da!
			switch (DSL_Packet[0]) {
				case 0x1F:  DSL_inArray[0][0] = DSL_Packet[0]; DSL_inArray[0][1] = DSL_Packet[1]; DSL_inArray[0][2] = DSL_Packet[2]; \
							DSL_inArray[0][3] = DSL_Packet[3]; DSL_inArray[0][4] = DSL_Packet[4]; DSL_inArray[0][5] = DSL_Packet[5]; \
							DSL_inArray[0][6] = DSL_Packet[6]; DSL_Header = DSL_Packet[0]; break;
				case 0x10:  DSL_inArray[1][0] = DSL_Packet[0]; DSL_inArray[1][1] = DSL_Packet[1]; DSL_inArray[1][2] = DSL_Packet[2]; \
							DSL_inArray[1][3] = DSL_Packet[3]; DSL_inArray[1][4] = DSL_Packet[4]; DSL_inArray[1][5] = DSL_Packet[5]; \
							DSL_Header = DSL_Packet[0]; break;
				case 0x12:  DSL_inArray[2][0] = DSL_Packet[0]; DSL_inArray[2][1] = DSL_Packet[1]; DSL_inArray[2][2] = DSL_Packet[2]; \
							DSL_inArray[2][3] = DSL_Packet[3]; DSL_inArray[2][4] = DSL_Packet[4]; DSL_inArray[2][5] = DSL_Packet[5]; \
							DSL_Header = DSL_Packet[0]; break;
				case 0x14:	DSL_inArray[3][0] = DSL_Packet[0]; DSL_inArray[3][1] = DSL_Packet[1]; DSL_inArray[3][2] = DSL_Packet[2]; \
							DSL_inArray[3][3] = DSL_Packet[3]; DSL_inArray[3][4] = DSL_Packet[4]; DSL_inArray[3][5] = DSL_Packet[5]; \
							DSL_Header = DSL_Packet[0]; break;
				case 0x16:  DSL_inArray[4][0] = DSL_Packet[0]; DSL_inArray[4][1] = DSL_Packet[1]; DSL_inArray[4][2] = DSL_Packet[2]; \
							DSL_inArray[4][3] = DSL_Packet[3]; DSL_inArray[4][4] = DSL_Packet[4]; DSL_inArray[4][5] = DSL_Packet[5]; \
							DSL_Header = DSL_Packet[0]; break;
				case 0x18:	DSL_inArray[5][0] = DSL_Packet[0]; DSL_inArray[5][1] = DSL_Packet[1]; DSL_inArray[5][2] = DSL_Packet[2]; \
							DSL_inArray[5][3] = DSL_Packet[3]; DSL_inArray[5][4] = DSL_Packet[4]; DSL_inArray[5][5] = DSL_Packet[5]; \
							DSL_Header = DSL_Packet[0]; break;
				default: break;
			}
		DSL_fill_outArray();
		}
		Byte_Count = 0;
		Checksum = 0;
	} else {
		DSL_Packet[Byte_Count] = Byte;
		Checksum += Byte;
		Byte_Count++;
	}
	Last_Byte = Byte;
}

#endif